PLaSK library

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | Static Public Attributes | List of all members
plask::RectangularMaskedMesh3D::BoundaryNodeSetImpl< CHANGE_DIR_SLOWER, CHANGE_DIR_FASTER > Struct Template Reference

`#include <plask/mesh/rectangular_masked3d.hpp>`

Inheritance diagram for plask::RectangularMaskedMesh3D::BoundaryNodeSetImpl< CHANGE_DIR_SLOWER, CHANGE_DIR_FASTER >:
[legend]
Collaboration diagram for plask::RectangularMaskedMesh3D::BoundaryNodeSetImpl< CHANGE_DIR_SLOWER, CHANGE_DIR_FASTER >:
[legend]

## Public Member Functions
| BoundaryNodeSetImpl (const RectangularMaskedMeshBase< DIM > &mesh, Vec< 3, std::size_t > index, std::size_t indexSlowerEnd, std::size_t indexFasterEnd)
| BoundaryNodeSetImpl (const RectangularMaskedMeshBase< DIM > &mesh, std::size_t index0, std::size_t index1, std::size_t index2, std::size_t indexSlowerEnd, std::size_t indexFasterEnd)
bool | contains (std::size_t mesh_index) const override
| Check if boundary contains point with given index.
const_iterator | begin () const override
| Get begin iterator over boundary points.
const_iterator | end () const override
| Get end iterator over boundary points.
Public Member Functions inherited from plask::BoundaryNodeSetWithMeshImpl< RectangularMaskedMeshBase< 3 > >
| BoundaryNodeSetWithMeshImpl (const RectangularMaskedMeshBase< 3 > &mesh)
| Construct object which holds reference to given `mesh`.
Public Member Functions inherited from plask::BoundaryNodeSetImpl
virtual | ~BoundaryNodeSetImpl ()
virtual bool | empty () const
| Check if this represents empty set of indexes.
virtual std::size_t | size () const
| Get number of points in this boundary.

## Public Attributes
Vec< 3, std::size_t > | index
| first index
std::size_t | indexFasterEnd
| past the last index of change directions
std::size_t | indexSlowerEnd
Public Attributes inherited from plask::BoundaryNodeSetWithMeshImpl< RectangularMaskedMeshBase< 3 > >
const RectangularMaskedMeshBase< 3 > & | mesh
| Held mesh.

## Static Public Attributes
static constexpr int | FIXED_DIR = 3 - CHANGE_DIR_SLOWER - CHANGE_DIR_FASTER

## Additional Inherited Members
Public Types inherited from plask::BoundaryNodeSetWithMeshImpl< RectangularMaskedMeshBase< 3 > >
typedef BoundaryNodeSetImpl::const_iterator | const_iterator
| iterator over indexes of mesh
typedef BoundaryNodeSetImpl::iterator | iterator
| iterator over indexes of mesh
Public Types inherited from plask::BoundaryNodeSetImpl
typedef PolymorphicForwardIteratorImpl< std::size_t, std::size_t > | IteratorImpl
| Base class for boundary iterator implementation.
typedef PolymorphicForwardIterator< IteratorImpl > | Iterator
| Boundary iterator type.
typedef Iterator | const_iterator
| iterator over indexes of mesh
typedef const_iterator | iterator

## Detailed Description

template<int CHANGE_DIR_SLOWER, int CHANGE_DIR_FASTER>
struct plask::RectangularMaskedMesh3D::BoundaryNodeSetImpl< CHANGE_DIR_SLOWER, CHANGE_DIR_FASTER >

Definition at line 703 of file rectangular_masked3d.hpp.

## Constructor & Destructor Documentation

## ◆ BoundaryNodeSetImpl() [1/2]

template<int CHANGE_DIR_SLOWER, int CHANGE_DIR_FASTER>

plask::RectangularMaskedMesh3D::BoundaryNodeSetImpl< CHANGE_DIR_SLOWER, CHANGE_DIR_FASTER >::BoundaryNodeSetImpl | ( | const RectangularMaskedMeshBase< DIM > & | mesh,
|  | Vec< 3, std::size_t > | index,
|  | std::size_t | indexSlowerEnd,
|  | std::size_t | indexFasterEnd
| ) |  |
| inline

Definition at line 715 of file rectangular_masked3d.hpp.

## ◆ BoundaryNodeSetImpl() [2/2]

template<int CHANGE_DIR_SLOWER, int CHANGE_DIR_FASTER>

plask::RectangularMaskedMesh3D::BoundaryNodeSetImpl< CHANGE_DIR_SLOWER, CHANGE_DIR_FASTER >::BoundaryNodeSetImpl | ( | const RectangularMaskedMeshBase< DIM > & | mesh,
|  | std::size_t | index0,
|  | std::size_t | index1,
|  | std::size_t | index2,
|  | std::size_t | indexSlowerEnd,
|  | std::size_t | indexFasterEnd
| ) |  |
| inline

Definition at line 718 of file rectangular_masked3d.hpp.

## Member Function Documentation

## ◆ begin()

template<int CHANGE_DIR_SLOWER, int CHANGE_DIR_FASTER>

const_iterator plask::RectangularMaskedMesh3D::BoundaryNodeSetImpl< CHANGE_DIR_SLOWER, CHANGE_DIR_FASTER >::begin | ( |  | ) | const
| inline override virtual

Get begin iterator over boundary points.

Returns
  begin iterator over boundary points

Implements plask::BoundaryNodeSetImpl.

Definition at line 729 of file rectangular_masked3d.hpp.

## ◆ contains()

template<int CHANGE_DIR_SLOWER, int CHANGE_DIR_FASTER>

bool plask::RectangularMaskedMesh3D::BoundaryNodeSetImpl< CHANGE_DIR_SLOWER, CHANGE_DIR_FASTER >::contains | ( | std::size_t | mesh_index | ) | const
| inline override virtual

Check if boundary contains point with given index.

Parameters

  mesh_index | valid index of point in `mesh`

Returns
  `true` only if point with index `mesh_index` in `mesh` lies on boundary

Implements plask::BoundaryNodeSetImpl.

Definition at line 721 of file rectangular_masked3d.hpp.

## ◆ end()

template<int CHANGE_DIR_SLOWER, int CHANGE_DIR_FASTER>

const_iterator plask::RectangularMaskedMesh3D::BoundaryNodeSetImpl< CHANGE_DIR_SLOWER, CHANGE_DIR_FASTER >::end | ( |  | ) | const
| inline override virtual

Get end iterator over boundary points.

Returns
  end iterator over boundary points

Implements plask::BoundaryNodeSetImpl.

Definition at line 733 of file rectangular_masked3d.hpp.

## Member Data Documentation

## ◆ FIXED_DIR

template<int CHANGE_DIR_SLOWER, int CHANGE_DIR_FASTER>

constexpr int plask::RectangularMaskedMesh3D::BoundaryNodeSetImpl< CHANGE_DIR_SLOWER, CHANGE_DIR_FASTER >::FIXED_DIR = 3 - CHANGE_DIR_SLOWER - CHANGE_DIR_FASTER
| static constexpr

Definition at line 705 of file rectangular_masked3d.hpp.

## ◆ index

template<int CHANGE_DIR_SLOWER, int CHANGE_DIR_FASTER>

Vec<3, std::size_t> plask::RectangularMaskedMesh3D::BoundaryNodeSetImpl< CHANGE_DIR_SLOWER, CHANGE_DIR_FASTER >::index

first index

Definition at line 710 of file rectangular_masked3d.hpp.

## ◆ indexFasterEnd

template<int CHANGE_DIR_SLOWER, int CHANGE_DIR_FASTER>

std::size_t plask::RectangularMaskedMesh3D::BoundaryNodeSetImpl< CHANGE_DIR_SLOWER, CHANGE_DIR_FASTER >::indexFasterEnd

past the last index of change directions

Definition at line 713 of file rectangular_masked3d.hpp.

## ◆ indexSlowerEnd

template<int CHANGE_DIR_SLOWER, int CHANGE_DIR_FASTER>

std::size_t plask::RectangularMaskedMesh3D::BoundaryNodeSetImpl< CHANGE_DIR_SLOWER, CHANGE_DIR_FASTER >::indexSlowerEnd

Definition at line 713 of file rectangular_masked3d.hpp.

The documentation for this struct was generated from the following file:

- plask/mesh/rectangular_masked3d.hpp